diff a/test/hotspot/jtreg/runtime/valhalla/inlinetypes/testSupers/NotAbstract.java b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/testSupers/NotAbstract.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/testSupers/NotAbstract.java
@@ -0,0 +1,25 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+public class NotAbstract { }
diff a/test/hotspot/jtreg/runtime/valhalla/inlinetypes/testSupers/TestSuperClasses.java b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/testSupers/TestSuperClasses.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/testSupers/TestSuperClasses.java
@@ -0,0 +1,97 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+/*
+ * @ignore Fix JDK-8328419
+ * @test
+ * @bug 8243204
+ * @summary test that the JVM detects illegal super classes for value object
+ *           and primitive value types.
+ * @enablePreview
+ * @compile NotAbstract.java HasNonStaticFields.java CtorHasArgs.java CtorIsNotEmpty.java
+ * @compile HasSynchMethod.java ValidSuper.java
+ * @compile InlineClassWithBadSupers.jcod
+ * @run main/othervm -verify TestSuperClasses
+ */
+
+public class TestSuperClasses {
+
+    public static void runTestIncompatibleClassChangeError(String test_name, String message) throws Exception {
+        System.out.println("Testing: " + test_name);
+        try {
+            Class newClass = Class.forName(test_name);
+            throw new RuntimeException("Expected IncompatibleClassChangeError exception not thrown");
+        } catch (java.lang.IncompatibleClassChangeError e) {
+            if (!e.getMessage().contains(message)) {
+                throw new RuntimeException("Wrong IncompatibleClassChangeError: " + e.getMessage());
+            }
+        }
+    }
+
+    public static void main(String[] args) throws Exception {
+
+        // Value Objects...
+
+        // Test that the super class of an value type must be java.lang.Object or an abstract class.
+        runTestIncompatibleClassChangeError("ValueSuperNotAbstract",
+            "Value type ValueSuperNotAbstract has an identity type as supertype");
+
+        // Test that the super class of an value type cannot have instance fields.
+        runTestIncompatibleClassChangeError("ValueSuperHasNonStaticFields",
+            "Value type ValueSuperHasNonStaticFields has an identity type as supertype");
+
+        // Test that the super class of an value type cannot contain a synchronized instance method.
+        runTestIncompatibleClassChangeError("ValueSuperHasSynchMethod",
+            "Value type ValueSuperHasSynchMethod has an identity type as supertype");
+
+        // Test that the constructor in a super class of an value type must have a signature of "()V".
+        runTestIncompatibleClassChangeError("ValueSuperCtorHasArgs",
+            "Value type ValueSuperCtorHasArgs has an identity type as supertype");
+
+        // Test that the constructor in a super class of an value type must be empty.
+        runTestIncompatibleClassChangeError("ValueSuperCtorIsNotEmpty",
+            "Value type ValueSuperCtorIsNotEmpty has an identity type as supertype");
+
+        // Primitive values...
+
+        // Test that the super class of an primitive value type must be java.lang.Object or an abstract class.
+        runTestIncompatibleClassChangeError("PrimitiveSuperNotAbstract",
+            "Value type PrimitiveSuperNotAbstract has an identity type as supertype");
+
+        // Test that the super class of an primitive value type cannot have instance fields.
+        runTestIncompatibleClassChangeError("PrimitiveSuperHasNonStaticFields",
+            "Value type PrimitiveSuperHasNonStaticFields has an identity type as supertype");
+
+        // Test that the super class of an primitive value type cannot contain a synchronized instance method.
+        runTestIncompatibleClassChangeError("PrimitiveSuperHasSynchMethod",
+            "Value type PrimitiveSuperHasSynchMethod has an identity type as supertype");
+
+        // Test that the constructor in a super class of an primitive value type must have a signature of "()V".
+        runTestIncompatibleClassChangeError("PrimitiveSuperCtorHasArgs",
+            "Value type PrimitiveSuperCtorHasArgs has an identity type as supertype");
+
+        // Test that the constructor in a super class of an primitive value type must be empty.
+        runTestIncompatibleClassChangeError("PrimitiveSuperCtorIsNotEmpty",
+            "Value type PrimitiveSuperCtorIsNotEmpty has an identity type as supertype");
+    }
+}
diff a/test/hotspot/jtreg/runtime/valhalla/inlinetypes/testSupers/ValidSuper.java b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/testSupers/ValidSuper.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/testSupers/ValidSuper.java
@@ -0,0 +1,34 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+// This abstract class is a valid super class for an inline type, but its
+// super class, HasSynchMethod, is not because it contains a synchronized
+// instance method.
+public abstract class ValidSuper extends HasSynchMethod {
+    public static String hi;
+    public static synchronized void helloWorld() { }
+    public void hi(int a) {
+        System.out.println("hi");
+    }
+}
diff a/test/hotspot/jtreg/runtime/valhalla/inlinetypes/verifier/VTAssignability.java b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/verifier/VTAssignability.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/verifier/VTAssignability.java
@@ -0,0 +1,79 @@
+/*
+ * Copyright (c) 2018, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @ignore Fix JDK-8328438
+ * @test
+ * @summary Test basic verifier assignability of inline types.
+ * @enablePreview
+ * @compile VTAssignability.java
+ * @run main/othervm -Xverify:remote VTAssignability
+ */
+
+// Test that an inline type is assignable to itself, to java.lang.Object,
+// and to an interface,
+//
+interface II { }
+
+public primitive final class VTAssignability implements II {
+    final int x;
+    final int y;
+
+    public VTAssignability(int x, int y) {
+        this.x = x;
+        this.y = y;
+    }
+
+    public int getX() { return x; }
+    public int getY() { return y; }
+
+    public boolean isSameVTAssignability(VTAssignability that) {
+        return this.getX() == that.getX() && this.getY() == that.getY();
+    }
+
+    public boolean equals(Object o) {
+        if(o instanceof VTAssignability) {
+            return ((VTAssignability)o).x == x &&  ((VTAssignability)o).y == y;
+        } else {
+            return false;
+        }
+    }
+
+    public void takesInterface(II i) {
+        System.out.println("Test passes!!");
+    }
+
+    public static void main(String[] args) {
+        VTAssignability a = new VTAssignability(3, 4);
+        VTAssignability b = new VTAssignability(2, 4);
+
+        // Test assignability of an inline type to itself.
+        boolean res = a.isSameVTAssignability(b);
+
+        // Test assignability of an inline type to java.lang.Object.
+        res = b.equals(a);
+
+        // Test assignability of an inline type to an interface.
+        a.takesInterface(b);
+    }
+}
diff a/test/hotspot/jtreg/runtime/valhalla/inlinetypes/verifier/VTMonitor.java b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/verifier/VTMonitor.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/verifier/VTMonitor.java
@@ -0,0 +1,52 @@
+/*
+ * Copyright (c) 2019, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @bug 8227373
+ * @summary Test that verifier allows monitor operations on inline types.
+ * @enablePreview
+ * @compile  VTMonitor.java
+ * @run main/othervm -Xverify:remote VTMonitor
+ */
+
+public value final class VTMonitor {
+    final int x;
+    final int y;
+
+    public VTMonitor(int x, int y) {
+        this.x = x;
+        this.y = y;
+    }
+
+    public static void main(String[] args) {
+        Object a = new VTMonitor(3, 4);
+        try {
+            synchronized(a) {
+                throw new RuntimeException("Synchronization on inline type should fail");
+            }
+        } catch (java.lang.IllegalMonitorStateException e) {
+            // Expected
+        }
+    }
+}
diff a/test/hotspot/jtreg/runtime/valhalla/inlinetypes/verifier/VerifierInlineTypes.java b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/verifier/VerifierInlineTypes.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/valhalla/inlinetypes/verifier/VerifierInlineTypes.java
@@ -0,0 +1,105 @@
+/*
+ * Copyright (c) 2018, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+/*
+ * @ignore Fix JDK-8328423
+ * @test
+ * @bug 8223028
+ * @summary test that the right exceptions get thrown for bad inline type
+ *          class files.
+ * @enablePreview
+ * @compile verifierTests.jcod
+ * @run main/othervm -verify VerifierInlineTypes
+ */
+
+public class VerifierInlineTypes {
+
+    public static void runTestVerifyError(String test_name, String message) throws Exception {
+        System.out.println("Testing: " + test_name);
+        try {
+            Class newClass = Class.forName(test_name);
+            throw new RuntimeException("Expected VerifyError exception not thrown");
+        } catch (java.lang.VerifyError e) {
+            if (!e.getMessage().contains(message)) {
+                throw new RuntimeException("Wrong VerifyError: " + e.getMessage());
+            }
+        }
+    }
+
+    public static void runTestFormatError(String test_name, String message) throws Exception {
+        System.out.println("Testing: " + test_name);
+        try {
+            Class newClass = Class.forName(test_name);
+            throw new RuntimeException("Expected ClassFormatError exception not thrown");
+        } catch (java.lang.ClassFormatError e) {
+            if (!e.getMessage().contains(message)) {
+                throw new RuntimeException("Wrong ClassFormatError: " + e.getMessage());
+            }
+        }
+    }
+
+    public static void runTestNoError(String test_name) throws Exception {
+        System.out.println("Testing: " + test_name);
+        Class newClass = Class.forName(test_name);
+    }
+
+    public static void main(String[] args) throws Exception {
+
+        // Test that a aconst_init opcode with an out of bounds cp index causes a VerifyError.
+        runTestVerifyError("defValBadCP", "Illegal constant pool index");
+
+        // Test that ClassFormatError is thrown for a class file, with major version 54, that
+        // contains a aconst_init opcode.
+        runTestFormatError("defValBadMajorVersion", "aconst_init not supported by this class file version");
+
+        // Test VerifyError is thrown if a aconst_init's cp entry is not a class.
+        runTestVerifyError("defValWrongCPType", "Illegal type at constant pool entry");
+
+        // Test that a withfield opcode with an out of bounds cp index causes a VerifyError.
+        runTestVerifyError("wthFldBadCP", "Illegal constant pool index");
+
+        // Test that VerifyError is thrown if the first operand on the stack is not assignable
+        // to withfield's field.
+        runTestVerifyError("wthFldBadFldVal", "Bad type on operand stack");
+
+        // Test that VerifyError is thrown if the second operand on the stack is a primitive.
+        runTestVerifyError("wthFldBadFldRef", "Bad type on operand stack");
+
+        // Test that ClassFormatError is thrown for a class file, with major version 54, that
+        // contains a withfield opcode.
+        runTestFormatError("wthFldBadMajorVersion", "withfield not supported by this class file version");
+
+        // Test VerifyError is thrown if a withfields's cp entry is not a field.
+        runTestVerifyError("wthFldWrongCPType", "Illegal type at constant pool entry");
+
+        // Test VerifyError is thrown if a aconst_init's cp entry is not an inline type.
+        runTestVerifyError("defValueObj", "Illegal type at constant pool entry 4");
+
+        // Test that the verifier doesn't require that a withfield bytecode has a Q type operand.
+        Class newClass = Class.forName("withfieldL");
+
+        // Test that null is not assignable to an inline type.
+        runTestVerifyError("NoNullVT",
+            "Type null (current frame, stack[1]) is not assignable to 'QNoNullVT;'");
+    }
+}
